<?php
require_once '../../classes/dao.php';


if (isset($_GET['function'])) {
    if ($_GET['function'] == "get_scores")
        get_scores();
    elseif ($_GET['function'] == "get_map_info")
        get_map_info();
    elseif ($_GET['function'] == "get_activities_of_day")
        get_activities_of_day();
    elseif ($_GET['function'] == "get_enigma_code")
        get_enigma_code();
    elseif ($_GET['function'] == "get_plaquette_code")
        get_plaquette_code();
} else
    show_error();

function get_map_selectors() {
    header('Content-Type: application/json');
    $dao = new Dao();
    echo json_encode($dao->get_map_selectors());
}

function get_scores() {
    if (isset($_GET['team'])) {
        header('Content-Type: application/json');
        $dao = new Dao();
        echo json_encode($dao->get_score_team($_GET['team']));
    } else {
        show_error();
    }
}

function get_map_info() {
    if (isset($_GET['selector'])) {
        header('Content-Type: application/json');
        $dao = new Dao();
        echo json_encode($dao->get_map_info($_GET['selector']));
    } else {
        show_error();
    }
}


function get_activities_of_day() {
    if (isset($_GET['day'])) {
        header('Content-Type: application/json');
        $dao = new Dao();
        echo json_encode($dao->get_activities_of_day($_GET['day']));
    } else {
        show_error();
    }
}

//
// Section pour les énigmes
//

function isFirstTeamToSolve($score_data) {
    $team   =   $score_data['team'];
    $enigme =   $score_data['text'];
    $dao = new Dao();
    $scorePek = $dao->get_score_team('pek');
    $scoreBoo = $dao->get_score_team('boo');
    $score = array_merge($scorePek, $scoreBoo);

    foreach($score as $value) {

        if ($value['text'] == $enigme)
            return false;
    }
    return true;
}


function get_enigma_code() {
    if (isset($_GET['code'])) {
        $data = array(
            "name" => $_GET['code'],
            "info" => null,
        );

        $team = $_GET['team'];

        $score_data = array(
            "text" => null,
            "points" => 0,
            "team" => $team,
        );


        switch ($_GET['code']) {
            case '501432' :
                $data["name"] = "enigme-1";
                $score_data["text"] = 'Énigme 1';
                $score_data["points"] = 200;

                if($_GET['date'] < 1627221618 ) {
                    $data["info"] = "<h2>Énigme 1</h2>Code trouvé, reviens demain pour avoir la suite ;)";
                } else {
                    $data["info"] = "<h2>Énigme 1</h2>
                        <p>Petit Pionnier Aguerri, dans l'arène, les déplacements des combattants sont tous enregistrés, voici le déplacement d'un combattant d'un district concurrant, à toi de le retrouver ! <br>
                        nord, nord, nord, est, sud-est, sud-ouest, ouest; <br>
                        ouest, sud, est, ouest, sud, est; <br>
                        ouest, sud, est, ouest, sud, est; <br>
                        est, est, est, ouest, sud, sud, sud; <br>
                        nord,nord,nord-est, , sud-est, sud, sud, nord, ouest; <br>
                        </p>";
                    if(isFirstTeamToSolve($score_data)) {
                        $dao = new Dao();
                        $dao->add_score($score_data);
                    }
                }
                echo json_encode($data, JSON_FORCE_OBJECT);
                break;
                
            case 'PEETA' :
                $data["name"] = "enigme-2";
                $score_data["text"] = 'Énigme 2';
                $score_data["points"] = 500;

                if($_GET['date'] < 1628361000 ) {
                    $data["info"] = "<h2>Énigme 2</h2>Code trouvé, reviens demain pour avoir la suite ;)";
                } else {
                    $data["info"] = "<h2>Énigme 2</h2>Dès l'aube, un oiseau aux sifflements merveilleux fit son apparition sur l'arène de l'INSA";
                    if(isFirstTeamToSolve($score_data)) {
                        $dao = new Dao();
                        $dao->add_score($score_data);
                    }
                }
                echo json_encode($data, JSON_FORCE_OBJECT);
                break;

            default:
                $data["name"] = null;
                $points_data["points"] = 0;

                echo json_encode($data, JSON_FORCE_OBJECT);
                break;
        }

    }
}

function get_plaquette_code() {
    if (isset($_GET['code'])) {
        $data = array(
            "name" => $_GET['code'],
            "info" => null,
        );
        switch ($_GET['code']) {
            case 'onlyfan_420' :
                $data["name"] = "onlyfan";
                $data["info"] = "Go follow sur insta <a href=\"https://www.instagram.com/onlyfan_420/\">@onlyfan_420</a>";
                echo json_encode($data, JSON_FORCE_OBJECT);
                break;

            case 'caché par ici' :
                $data["name"] = "plaquette1";
                $data["info"] = "<a  href=\"assets/pdf/Enigme_plaquette_1.pdf\">Énigme plaquette</a>";
                echo json_encode($data, JSON_FORCE_OBJECT);
                break;
            case 'SURVIVANT' :
                $data["name"] = "plaquette2";
                $data["info"] = "<iframe width=\"560\" height=\"315\" 
                        src=\"https://www.youtube.com/embed/F3hTW9e20d8?autoplay=1\" allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture\" allowfullscreen></iframe>
                    <p style=\"white-space:pre;\">@               <span style=\"color:#1c1c1c;\">promo59</span></p>
                    ";
                echo json_encode($data, JSON_FORCE_OBJECT);
                break;
            default:
                $data["name"] = null;
                echo json_encode($data, JSON_FORCE_OBJECT);

                break;
        }

    }
}


function show_error() {
    echo "Échec : ";
    var_dump($_GET);
}
